#include <stdio.h>

#define TRUE 1
#define FALSE 0

int main(int argc, char **argv)
{
	short val, testVal;
	char *p_val, *t_val;
	p_val = (char *) &val;
	t_val = (char *) &testVal;
	int bigEndian = TRUE;
	
	
	//test for endianess by assuming little endian, if the test fails then we know its big endian
	t_val[1] = 0x12;
	t_val[0] = 0x34;
	//if the value is correct, then it is little endian, else it is big endian
	if(testVal == 0x1234)
	{
		bigEndian = FALSE;
		printf("Little Endian\n");
	}
	else
	{
		bigEndian = FALSE;
		printf("Big Endian, testVal is %d\n", testVal);
	}
	
	
	
	//now actual create the variable based on the endianess tested above.
	if(bigEndian == FALSE)
	{
		p_val[1] = 0x12;
		p_val[0] = 0x34;
	}
	else
	{
		p_val[0] = 0x12;
		p_val[1] = 0x34;
	}
	
	printf("%x\n", val);
	
	return 0;
}
